diff --git a/sys/sys/param.h b/sys/sys/param.h
index 22699637ee..f38a584e7f 100644
--- a/sys/sys/param.h
+++ b/sys/sys/param.h
@@ -207,9 +207,10 @@
  * 500702 - TCP_KEEP* milliseconds -> seconds
  * 500703 - Static TLS bindings support for late-loaded shared libraries
  * 500704 - Announce IP6 address flag changes via route(4)
+ * 500705 - Move us to utmpx, delete utmp
  */
 #undef __DragonFly_version
-#define __DragonFly_version 500704	/* propagated to newvers */
+#define __DragonFly_version 500705	/* propagated to newvers */
 
 #include <sys/_null.h>
 
@@ -222,13 +223,12 @@
  * Redefined constants are from POSIX 1003.1 limits file.
  *
  * MAXCOMLEN should be >= sizeof(ac_comm) (see <acct.h>)
- * MAXLOGNAME should be == UT_NAMESIZE+1 (see <utmp.h>)
  */
 #include <sys/syslimits.h>
 
 #define MAXCOMLEN	16		/* max command name remembered */
 #define MAXINTERP	32		/* max interpreter file name length */
-#define MAXLOGNAME	17		/* max login name length (incl. NUL) */
+#define MAXLOGNAME	33		/* max login name length (incl. NUL) */
 #define MAXUPRC		CHILD_MAX	/* max simultaneous processes */
 #define NCARGS		ARG_MAX		/* max bytes for an exec function */
 #define NGROUPS		NGROUPS_MAX	/* max number groups */
diff --git a/usr.bin/Makefile b/usr.bin/Makefile
index 85a3597050..d009d71604 100644
--- a/usr.bin/Makefile
+++ b/usr.bin/Makefile
@@ -238,6 +238,7 @@ SUBDIR=	alias \
 	window \
 	wmake \
 	write \
+	wtmpcvt \
 	xargs \
 	xinstall \
 	xstr \
diff --git a/usr.bin/finger/Makefile b/usr.bin/finger/Makefile
index 5ad7fed9e2..c1bd7c4da9 100644
--- a/usr.bin/finger/Makefile
+++ b/usr.bin/finger/Makefile
@@ -10,6 +10,6 @@ MAN=	finger.1 finger.conf.5
 DPADD+=	${LIBUTIL}
 LDADD+=	-lutil
 
-CFLAGS+= -I${.CURDIR}/../who -DSUPPORT_UTMP -DSUPPORT_UTMPX
+CFLAGS+= -I${.CURDIR}/../who
 
 .include <bsd.prog.mk>
diff --git a/usr.bin/finger/lprint.c b/usr.bin/finger/lprint.c
index 933f6ed4c1..abec08f9ff 100644
--- a/usr.bin/finger/lprint.c
+++ b/usr.bin/finger/lprint.c
@@ -31,7 +31,6 @@
  *
  * @(#)lprint.c	8.3 (Berkeley) 4/28/95
  * $FreeBSD: src/usr.bin/finger/lprint.c,v 1.10.2.4 2002/07/03 01:14:24 des Exp $
- * $DragonFly: src/usr.bin/finger/lprint.c,v 1.4 2004/09/03 19:13:23 dillon Exp $
  */
 
 #include <sys/types.h>
@@ -48,7 +47,6 @@
 #include <stdio.h>
 #include <string.h>
 #include <unistd.h>
-#include <utmp.h>
 #include "finger.h"
 #include "pathnames.h"
 #include "extern.h"
diff --git a/usr.bin/finger/net.c b/usr.bin/finger/net.c
index 514160300c..21ccb55c1a 100644
--- a/usr.bin/finger/net.c
+++ b/usr.bin/finger/net.c
@@ -45,7 +45,6 @@
 #include <stdlib.h>
 #include <string.h>
 #include <unistd.h>
-#include <utmp.h>
 #include "finger.h"
 
 static void cleanup(int sig);
diff --git a/usr.bin/finger/sprint.c b/usr.bin/finger/sprint.c
index e8620bc58c..7e1eaa9e31 100644
--- a/usr.bin/finger/sprint.c
+++ b/usr.bin/finger/sprint.c
@@ -31,9 +31,9 @@
  *
  * @(#)sprint.c	8.3 (Berkeley) 4/28/95
  * $FreeBSD: src/usr.bin/finger/sprint.c,v 1.11.2.5 2002/07/03 01:14:24 des Exp $
- * $DragonFly: src/usr.bin/finger/sprint.c,v 1.4 2008/02/09 17:12:05 matthias Exp $
  */
 
+#include <sys/param.h>
 #include <sys/socket.h>
 #include <db.h>
 #include <err.h>
@@ -42,7 +42,6 @@
 #include <stdio.h>
 #include <string.h>
 #include <time.h>
-#include <utmp.h>
 #include "finger.h"
 
 static void	  stimeprint(WHERE *);
@@ -78,7 +77,7 @@ sflag_print(void)
 	 */
 #define	MAXREALNAME	20
 #define MAXHOSTNAME     17      /* in reality, hosts are never longer than 16 */
-	(void)printf("%-*s %-*s%s  %s\n", UT_NAMESIZE, "Login", MAXREALNAME,
+	(void)printf("%-*s %-*s%s  %s\n", MAXLOGNAME, "Login", MAXREALNAME,
 	    "Name", " TTY  Idle  Login  Time ", (gflag) ? "" :
 	    oflag ? "Office  Phone" : "Where");
 
@@ -95,7 +94,7 @@ sflag_print(void)
 			namelen = MAXREALNAME;
 			if (w->info == LOGGEDIN && !w->writable)
 				--namelen;	/* leave space before `*' */
-			(void)printf("%-*.*s %-*.*s", UT_NAMESIZE, UT_NAMESIZE,
+			(void)printf("%-*.*s %-*.*s", MAXLOGNAME, MAXLOGNAME,
 				pn->name, MAXREALNAME, namelen,
 				pn->realname ? pn->realname : "");
 			if (!w->loginat) {
diff --git a/usr.bin/finger/util.c b/usr.bin/finger/util.c
index b45bd3afe9..49fd69cb77 100644
--- a/usr.bin/finger/util.c
+++ b/usr.bin/finger/util.c
@@ -31,7 +31,6 @@
  *
  * @(#)util.c	8.3 (Berkeley) 4/28/95
  * $FreeBSD: src/usr.bin/finger/util.c,v 1.8.2.6 2002/07/03 01:14:24 des Exp $
- * $DragonFly: src/usr.bin/finger/util.c,v 1.3 2003/10/04 20:36:44 hmp Exp $
  */
 
 #include <sys/param.h>
@@ -49,7 +48,7 @@
 #include <string.h>
 #include <unistd.h>
 #include "utmpentry.h"
-#include <utmp.h>
+#include <utmpx.h>
 #include "finger.h"
 #include "pathnames.h"
 
@@ -101,29 +100,18 @@ void
 enter_lastlog(PERSON *pn)
 {
 	WHERE *w;
-	static int opened, fd;
-	struct lastlog ll;
+	struct utmpx *ut = NULL;
 	char doit = 0;
 
-	/* some systems may not maintain lastlog, don't report errors. */
-	if (!opened) {
-		fd = open(_PATH_LASTLOG, O_RDONLY, 0);
-		opened = 1;
-	}
-	if (fd == -1 ||
-	    lseek(fd, (long)pn->uid * sizeof(ll), SEEK_SET) !=
-	    (off_t)((long)pn->uid * sizeof(ll)) ||
-	    read(fd, (char *)&ll, sizeof(ll)) != sizeof(ll)) {
-			/* as if never logged in */
-			ll.ll_line[0] = ll.ll_host[0] = '\0';
-			ll.ll_time = 0;
-		}
+	if (setutxdb(UTX_DB_LASTLOGX, NULL) == 0)
+		ut = getutxuser(pn->name);
 	if ((w = pn->whead) == NULL)
 		doit = 1;
-	else if (ll.ll_time != 0) {
+	else if (ut != NULL && ut->ut_type == USER_PROCESS) {
 		/* if last login is earlier than some current login */
 		for (; !doit && w != NULL; w = w->next)
-			if (w->info == LOGGEDIN && w->loginat < ll.ll_time)
+			if (w->info == LOGGEDIN &&
+			    w->loginat < ut->ut_tv.tv_sec)
 				doit = 1;
 		/*
 		 * and if it's not any of the current logins
@@ -132,16 +120,17 @@ enter_lastlog(PERSON *pn)
 		 */
 		for (w = pn->whead; doit && w != NULL; w = w->next)
 			if (w->info == LOGGEDIN &&
-			    strncmp(w->tty, ll.ll_line, UT_LINESIZE) == 0)
+			    strcmp(w->tty, ut->ut_line) == 0)
 				doit = 0;
 	}
-	if (doit) {
+	if (ut != NULL && doit) {
 		w = walloc(pn);
 		w->info = LASTLOG;
-		asprintf(&w->tty, "%s", ll.ll_line);
-		asprintf(&w->host, "%s", ll.ll_host);
-		w->loginat = ll.ll_time;
+		strcpy(w->tty, ut->ut_line);
+		strcpy(w->host, ut->ut_host);
+		w->loginat = ut->ut_tv.tv_sec;
 	}
+	endutxent();
 }
 
 void
@@ -197,10 +186,8 @@ find_person(char *name)
 {
 	struct passwd *pw;
 
-	int cnt;
 	DBT data, key;
 	PERSON *p;
-	char buf[UT_NAMESIZE + 1];
 
 	if (!db)
 		return(NULL);
@@ -208,12 +195,8 @@ find_person(char *name)
 	if ((pw = getpwnam(name)) && hide(pw))
 		return(NULL);
 
-	/* Name may be only UT_NAMESIZE long and not NUL terminated. */
-	for (cnt = 0; cnt < UT_NAMESIZE && *name; ++name, ++cnt)
-		buf[cnt] = *name;
-	buf[cnt] = '\0';
-	key.data = buf;
-	key.size = cnt;
+	key.data = name;
+	key.size = strlen(name);
 
 	if ((*db->get)(db, &key, &data, 0))
 		return (NULL);
diff --git a/usr.bin/last/Makefile b/usr.bin/last/Makefile
index 4e251316e1..df0c972808 100644
--- a/usr.bin/last/Makefile
+++ b/usr.bin/last/Makefile
@@ -3,6 +3,6 @@
 
 PROG=	last
 
-CFLAGS+=-DSUPPORT_UTMP -DSUPPORT_UTMPX -I${.CURDIR}/../../lib/libc/stdtime
+CFLAGS+=-I${.CURDIR}/../../lib/libc/stdtime
 
 .include <bsd.prog.mk>
diff --git a/usr.bin/last/last.c b/usr.bin/last/last.c
index 4a171d6e84..24dfd241f6 100644
--- a/usr.bin/last/last.c
+++ b/usr.bin/last/last.c
@@ -43,12 +43,7 @@
 #include <time.h>
 #include <tzfile.h>
 #include <unistd.h>
-#ifdef SUPPORT_UTMPX
 #include <utmpx.h>
-#endif
-#ifdef SUPPORT_UTMP
-#include <utmp.h>
-#endif
 
 #ifndef UT_NAMESIZE
 #define UT_NAMESIZE 8
@@ -94,6 +89,7 @@ typedef struct ttytab {
 } TTY;
 static TTY	*ttylist;		/* head of linked list */
 
+static struct utmpx *bufx;
 static time_t	currentout;		/* current logout value */
 static long	maxrec;			/* records to display */
 static int	fulltime = 0;		/* Display seconds? */
@@ -102,14 +98,11 @@ static void	 addarg(int, char *);
 static TTY	*addtty(const char *);
 static void	 hostconv(char *);
 static char	*ttyconv(char *);
-#ifdef SUPPORT_UTMPX
 static void	 wtmpx(const char *, int, int, int);
-#endif
-#ifdef SUPPORT_UTMP
-static void	 wtmp(const char *, int, int, int);
-#endif
 static char	*fmttime(time_t, int);
 static void	 usage(void);
+static void	 onintrx(int);
+static int	 wantx(struct utmpx *, int);
 
 static
 void usage(void)
@@ -195,40 +188,12 @@ main(int argc, char *argv[])
 		}
 	}
 	if (file == NULL) {
-		/* default to wtmpx */
-#ifdef SUPPORT_UTMPX
 		if (access(_PATH_WTMPX, R_OK) == 0)
 			file = _PATH_WTMPX;
-		else
-#endif
-#ifdef SUPPORT_UTMP
-		if (access(_PATH_WTMP, R_OK) == 0)
-			file = _PATH_WTMP;
-#endif
 		if (file == NULL)
-#if defined(SUPPORT_UTMPX) && defined(SUPPORT_UTMP)
-			errx(1, "Cannot access `%s' or `%s'", _PATH_WTMPX,
-			    _PATH_WTMP);
-#elif defined(SUPPORT_UTMPX)
 			errx(1, "Cannot access `%s'", _PATH_WTMPX);
-#elif defined(SUPPORT_UTMP)
-			errx(1, "Cannot access `%s'", _PATH_WTMP);
-#else
-			errx(1, "No utmp or utmpx support compiled in.");
-#endif
 	}
-#if defined(SUPPORT_UTMPX) && defined(SUPPORT_UTMP)
-	if (file[strlen(file) - 1] == 'x')
-		wtmpx(file, namesize, linesize, hostsize);
-	else
-		wtmp(file, namesize, linesize, hostsize);
-#elif defined(SUPPORT_UTMPX)
 	wtmpx(file, namesize, linesize, hostsize);
-#elif defined(SUPPORT_UTMP)
-	wtmp(file, namesize, linesize, hostsize);
-#else
-	errx(1, "No utmp or utmpx support compiled in.");
-#endif
 	exit(0);
 }
 
@@ -342,33 +307,199 @@ fmttime(time_t t, int flags)
 	return (tbuf);
 }
 
-#ifdef SUPPORT_UTMP
-#define TYPE(a)	0
-#define NAMESIZE UT_NAMESIZE
-#define LINESIZE UT_LINESIZE
-#define HOSTSIZE UT_HOSTSIZE
-#define ut_timefld ut_time
-#define FIRSTVALID 0
-#include "want.c"
-#undef TYPE
-#undef NAMESIZE
-#undef LINESIZE
-#undef HOSTSIZE
-#undef ut_timefld
-#undef FIRSTVALID
+/*
+ * wtmpx --
+ *	read through the wtmpx file
+ */
+static void
+wtmpx(const char *file, int namesz, int linesz, int hostsz)
+{
+	struct utmpx	*bp;		/* current structure */
+	TTY	*T;			/* tty list entry */
+	struct stat	stb;		/* stat of file for sz */
+	time_t	delta;			/* time difference */
+	off_t	bl;
+	int	bytes, wfd;
+	char	*ct;
+	const char *crmsg;
+	size_t  len = sizeof(*bufx) * MAXUTMP;
+
+	if ((bufx = malloc(len)) == NULL)
+		err(1, "Cannot allocate utmpx buffer");
+
+	crmsg = NULL;
+
+	if ((wfd = open(file, O_RDONLY, 0)) < 0 || fstat(wfd, &stb) == -1)
+		err(1, "%s", file);
+	bl = (stb.st_size + len - 1) / len;
+
+	bufx[1].ut_xtime = time(NULL);
+	(void)signal(SIGINT, onintrx);
+	(void)signal(SIGQUIT, onintrx);
+
+	while (--bl >= 0) {
+		if (lseek(wfd, bl * len, SEEK_SET) == -1 ||
+		    (bytes = read(wfd, bufx, len)) == -1)
+			err(1, "%s", file);
+		for (bp = &bufx[bytes / sizeof(*bufx) - 1]; bp >= bufx; --bp) {
+			/*
+			 * if the terminal line is '~', the machine stopped.
+			 * see utmpx(5) for more info.
+			 */
+			if (bp->ut_line[0] == '~' && !bp->ut_line[1]) {
+				/* everybody just logged out */
+				for (T = ttylist; T; T = T->next)
+					T->logout = -bp->ut_xtime;
+				currentout = -bp->ut_xtime;
+#ifdef __DragonFly__	/* XXX swildner: this should not be needed afaict */
+				if (!strncmp(bp->ut_name, "shutdown", namesz))
+					crmsg = "shutdown";
+				else if (!strncmp(bp->ut_name, "reboot", namesz))
+					crmsg = "reboot";
+				else
+					crmsg = "crash";
+#else
+				crmsg = strncmp(bp->ut_name, "shutdown",
+				    namesz) ? "crash" : "shutdown";
 #endif
+				if (wantx(bp, NO)) {
+					ct = fmttime(bp->ut_xtime, fulltime);
+					printf("%-*.*s  %-*.*s %-*.*s %s\n",
+					    namesz, namesz, bp->ut_name,
+					    linesz, linesz, bp->ut_line,
+					    hostsz, hostsz, bp->ut_host, ct);
+					if (maxrec != -1 && !--maxrec)
+						return;
+				}
+				continue;
+			}
+			/*
+			 * if the line is '{' or '|', date got set; see
+			 * utmpx(5) for more info.
+			 */
+			if ((bp->ut_line[0] == '{' || bp->ut_line[0] == '|')
+			    && !bp->ut_line[1]) {
+				if (wantx(bp, NO)) {
+					ct = fmttime(bp->ut_xtime, fulltime);
+				printf("%-*.*s  %-*.*s %-*.*s %s\n",
+				    namesz, namesz,
+				    bp->ut_name,
+				    linesz, linesz,
+				    bp->ut_line,
+				    hostsz, hostsz,
+				    bp->ut_host,
+				    ct);
+					if (maxrec && !--maxrec)
+						return;
+				}
+				continue;
+			}
+			/* find associated tty */
+			for (T = ttylist;; T = T->next) {
+				if (!T) {
+					/* add new one */
+					T = addtty(bp->ut_line);
+					break;
+				}
+				if (!strncmp(T->tty, bp->ut_line, UTX_LINESIZE))
+					break;
+			}
+			if (bp->ut_type == SIGNATURE)
+				continue;
+			if (bp->ut_name[0] && wantx(bp, YES)) {
+				ct = fmttime(bp->ut_xtime, fulltime);
+				printf("%-*.*s  %-*.*s %-*.*s %s ",
+				    namesz, namesz, bp->ut_name,
+				    linesz, linesz, bp->ut_line,
+				    hostsz, hostsz, bp->ut_host,
+				    ct);
+				if (!T->logout)
+					puts("  still logged in");
+				else {
+					if (T->logout < 0) {
+						T->logout = -T->logout;
+						printf("- %s", crmsg);
+					}
+					else
+						printf("- %s",
+						    fmttime(T->logout,
+						    fulltime | TIMEONLY));
+					delta = T->logout - bp->ut_xtime;
+					if (delta < SECSPERDAY)
+						printf("  (%s)\n",
+						    fmttime(delta,
+						    fulltime | TIMEONLY | GMT));
+					else
+						printf(" (%ld+%s)\n",
+						    delta / SECSPERDAY,
+						    fmttime(delta,
+						    fulltime | TIMEONLY | GMT));
+				}
+				if (maxrec != -1 && !--maxrec)
+					return;
+			}
+			T->logout = bp->ut_xtime;
+		}
+	}
+	fulltime = 1;	/* show full time */
+	crmsg = fmttime(bufx[1].ut_xtime, FULLTIME);
+	if ((ct = strrchr(file, '/')) != NULL)
+		ct++;
+	printf("\n%s begins %s\n", ct ? ct : file, crmsg);
+}
 
-#ifdef SUPPORT_UTMPX
-#define utmp utmpx
-#define want wantx
-#define wtmp wtmpx
-#define buf bufx
-#define onintr onintrx
-#define TYPE(a) (a)->ut_type
-#define NAMESIZE UTX_USERSIZE
-#define LINESIZE UTX_LINESIZE
-#define HOSTSIZE UTX_HOSTSIZE
-#define ut_timefld ut_xtime
-#define FIRSTVALID 1
-#include "want.c"
-#endif
+/*
+ * wantx --
+ *	see if want this entry
+ */
+static int
+wantx(struct utmpx *bp, int check)
+{
+	ARG *step;
+
+	if (check) {
+		/*
+		 * when uucp and ftp log in over a network, the entry in
+		 * the utmpx file is the name plus their process id.  See
+		 * etc/ftpd.c and usr.bin/uucp/uucpd.c for more information.
+		 */
+		if (!strncmp(bp->ut_line, "ftp", sizeof("ftp") - 1))
+			bp->ut_line[3] = '\0';
+		else if (!strncmp(bp->ut_line, "uucp", sizeof("uucp") - 1))
+			bp->ut_line[4] = '\0';
+	}
+	if (!arglist)
+		return (YES);
+
+	for (step = arglist; step; step = step->next)
+		switch(step->type) {
+		case HOST_TYPE:
+			if (!strncasecmp(step->name, bp->ut_host, UTX_HOSTSIZE))
+				return (YES);
+			break;
+		case TTY_TYPE:
+			if (!strncmp(step->name, bp->ut_line, UTX_LINESIZE))
+				return (YES);
+			break;
+		case USER_TYPE:
+			if (!strncmp(step->name, bp->ut_name, UTX_USERSIZE))
+				return (YES);
+			break;
+	}
+	return (NO);
+}
+
+/*
+ * onintrx --
+ *	on interrupt, we inform the user how far we've gotten
+ */
+static void
+onintrx(int signo)
+{
+
+	printf("\ninterrupted %s\n", fmttime(bufx[1].ut_xtime,
+	    FULLTIME));
+	if (signo == SIGINT)
+		exit(1);
+	(void)fflush(stdout);		/* fix required for rsh */
+}
diff --git a/usr.bin/systat/Makefile b/usr.bin/systat/Makefile
index 22bb0cbaca..28b9787714 100644
--- a/usr.bin/systat/Makefile
+++ b/usr.bin/systat/Makefile
@@ -21,6 +21,6 @@ LDADD+=	-lutil
 CFLAGS+=	-I${_SHLIBDIRPREFIX}/usr/include/priv/ncurses
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
 
-CFLAGS+= -I${.CURDIR}/../who -DSUPPORT_UTMP -DSUPPORT_UTMPX
+CFLAGS+= -I${.CURDIR}/../who
 
 .include <bsd.prog.mk>
diff --git a/usr.bin/users/Makefile b/usr.bin/users/Makefile
index b6caa023d1..ba84671853 100644
--- a/usr.bin/users/Makefile
+++ b/usr.bin/users/Makefile
@@ -7,6 +7,6 @@ SRCS=	users.c utmpentry.c
 DPADD=	${LIBUTIL}
 LDADD=	-lutil
 
-CFLAGS+= -I${.CURDIR}/../who -DSUPPORT_UTMP -DSUPPORT_UTMPX
+CFLAGS+= -I${.CURDIR}/../who
 
 .include <bsd.prog.mk>
diff --git a/usr.bin/w/Makefile b/usr.bin/w/Makefile
index cc05d02fd4..21b09fde95 100644
--- a/usr.bin/w/Makefile
+++ b/usr.bin/w/Makefile
@@ -12,7 +12,6 @@ LINKS=	${BINDIR}/w ${BINDIR}/uptime
 WARNS?=	3
 NO_STRICT_ALIASING=
 
-CFLAGS+=	-DSUPPORT_UTMP -DSUPPORT_UTMPX
 .PATH: ${.CURDIR}/../../bin/ps
 
 .include <bsd.prog.mk>
diff --git a/usr.bin/w/w.c b/usr.bin/w/w.c
index 86c23fbc65..7cca80da78 100644
--- a/usr.bin/w/w.c
+++ b/usr.bin/w/w.c
@@ -65,12 +65,7 @@
 #include <stdlib.h>
 #include <string.h>
 #include <unistd.h>
-#ifdef SUPPORT_UTMP
-#include <utmp.h>
-#endif
-#ifdef SUPPORT_UTMPX
 #include <utmpx.h>
-#endif
 #include <vis.h>
 
 #include <arpa/nameser.h>
@@ -79,9 +74,6 @@
 #include "extern.h"
 
 struct timeval	boottime;
-#ifdef SUPPORT_UTMP
-struct utmp	utmp;
-#endif
 struct winsize	ws;
 kvm_t	       *kd;
 time_t		now;		/* the current time of day */
@@ -120,10 +112,8 @@ struct	entry {
 #define debugproc(p) *((struct kinfo_proc **)&(p)->kp_spare[0])
 
 static void		 pr_header(time_t *, int);
-#if defined(SUPPORT_UTMP) || defined(SUPPORT_UTMPX)
 static struct stat	*ttystat(char *, int);
 static void	process(struct entry *);
-#endif
 static void		 usage(int);
 static int		 this_is_uptime(const char *s);
 
@@ -138,12 +128,7 @@ main(int argc, char **argv)
 	in_addr_t l;
 	int ch, i, nentries, nusers, wcmd, longidle, dropgid;
 	char *memf, *nlistf, *p, *x;
-#ifdef SUPPORT_UTMP
-	struct utmp *ut;
-#endif
-#ifdef SUPPORT_UTMPX
 	struct utmpx *utx;
-#endif
 	char buf[MAXHOSTNAMELEN], errbuf[_POSIX2_LINE_MAX];
 
 	(void)setlocale(LC_ALL, "");
@@ -210,18 +195,12 @@ main(int argc, char **argv)
 		errx(1, "%s", errbuf);
 
 	(void)time(&now);
-#ifdef SUPPORT_UTMPX
 	setutxent();
-#endif
-#ifdef SUPPORT_UTMP
-	setutent();
-#endif
 
 	if (*argv)
 		sel_users = argv;
 
 	nusers = 0;
-#ifdef SUPPORT_UTMPX
 	while ((utx = getutxent()) != NULL) {
 		if (utx->ut_type != USER_PROCESS)
 			continue;
@@ -266,59 +245,7 @@ main(int argc, char **argv)
 		if (wcmd != 0)
 			process(ep);
 	}
-#endif
-
-#ifdef SUPPORT_UTMP
-	while ((ut = getutent()) != NULL) {
-		if (ut->ut_name[0] == '\0')
-			continue;
-		++nusers;
-		if (sel_users) {
-			int usermatch;
-			char **user;
-
-			usermatch = 0;
-			for (user = sel_users; !usermatch && *user; user++)
-				if (!strncmp(ut->ut_name, *user, UT_NAMESIZE))
-					usermatch = 1;
-			if (!usermatch)
-				continue;
-		}
-
-		/* Don't process entries that we have utmpx for */
-		for (ep = ehead; ep != NULL; ep = ep->next) {
-			if (strncmp(ep->line, ut->ut_line,
-			    sizeof(ut->ut_line)) == 0)
-				break;
-		}
-		if (ep != NULL) {
-			--nusers; /* Duplicate entry */
-			continue;
-		}
-
-		if ((ep = calloc(1, sizeof(struct entry))) == NULL)
-			err(1, NULL);
-		(void)memcpy(ep->name, ut->ut_name, sizeof(ut->ut_name));
-		(void)memcpy(ep->line, ut->ut_line, sizeof(ut->ut_line));
-		(void)memcpy(ep->host, ut->ut_host, sizeof(ut->ut_host));
-		ep->name[sizeof(ut->ut_name)] = '\0';
-		ep->line[sizeof(ut->ut_line)] = '\0';
-		ep->host[sizeof(ut->ut_host)] = '\0';
-		ep->tv.tv_sec = ut->ut_time;
-
-		*nextp = ep;
-		nextp = &(ep->next);
-		if (wcmd != 0)
-			process(ep);
-	}
-#endif
-
-#ifdef SUPPORT_UTMPX
 	endutxent();
-#endif
-#ifdef SUPPORT_UTMP
-	endutent();
-#endif	
 	
 	if (header || wcmd == 0) {
 		pr_header(&now, nusers);
@@ -409,9 +336,7 @@ main(int argc, char **argv)
 			save->next = *nextp;
 			*nextp = save;
 		}
-	}
-#if defined(SUPPORT_UTMP) && defined(SUPPORT_UTMPX)
-	else if (ehead != NULL) {
+	} else if (ehead != NULL) {
 		struct entry *from = ehead, *save;
 
 		ehead = NULL;
@@ -426,7 +351,6 @@ main(int argc, char **argv)
 			*nextp = save;
 		}
 	}
-#endif
 
 	if (!nflag) {
 		if (gethostname(domain, sizeof(domain)) < 0 ||
@@ -610,7 +534,6 @@ this_is_uptime(const char *s)
 	return (-1);
 }
 
-#if defined(SUPPORT_UTMP) || defined(SUPPORT_UTMPX)
 static void
 process(struct entry *ep)
 {
@@ -656,4 +579,3 @@ process(struct entry *ep)
 	if ((ep->idle = now - touched) < 0)
 		ep->idle = 0;
 }
-#endif
diff --git a/usr.bin/wall/Makefile b/usr.bin/wall/Makefile
index 81e3c9638e..5c8b456d24 100644
--- a/usr.bin/wall/Makefile
+++ b/usr.bin/wall/Makefile
@@ -10,6 +10,6 @@ BINMODE=2555
 DPADD+=	${LIBUTIL}
 LDADD+=	-lutil
 
-CFLAGS+= -I${.CURDIR}/../who -DSUPPORT_UTMP -DSUPPORT_UTMPX
+CFLAGS+= -I${.CURDIR}/../who
 
 .include <bsd.prog.mk>
diff --git a/usr.bin/who/Makefile b/usr.bin/who/Makefile
index 68d3b1d324..df91528b2e 100644
--- a/usr.bin/who/Makefile
+++ b/usr.bin/who/Makefile
@@ -1,10 +1,6 @@
 #	@(#)Makefile	8.1 (Berkeley) 6/6/93
-# $DragonFly: src/usr.bin/who/Makefile,v 1.3 2007/08/27 16:51:01 pavalos Exp $
 
 PROG=	who
-
 SRCS+=	who.c utmpentry.c
 
-CFLAGS+=	-DSUPPORT_UTMPX -DSUPPORT_UTMP
-
 .include <bsd.prog.mk>
diff --git a/usr.bin/who/utmpentry.c b/usr.bin/who/utmpentry.c
index 324805edd0..a6427fbea3 100644
--- a/usr.bin/who/utmpentry.c
+++ b/usr.bin/who/utmpentry.c
@@ -37,13 +37,7 @@
 #include <stdlib.h>
 #include <string.h>
 #include <time.h>
-
-#ifdef SUPPORT_UTMP
-#include <utmp.h>
-#endif
-#ifdef SUPPORT_UTMPX
 #include <utmpx.h>
-#endif
 
 #include "utmpentry.h"
 
@@ -78,25 +72,16 @@
 #define	COMPILE_ASSERT(x)	_Static_assert(x, "assertion failed")
 
 
-#ifdef SUPPORT_UTMP
-static void getentry(struct utmpentry *, struct utmp *);
-static struct timespec utmptime = {0, 0};
-#endif
-#ifdef SUPPORT_UTMPX
 static void getentryx(struct utmpentry *, struct utmpx *);
 static struct timespec utmpxtime = {0, 0};
-#endif
-#if defined(SUPPORT_UTMPX) || defined(SUPPORT_UTMP)
 static int setup(const char *);
 static void adjust_size(struct utmpentry *e);
-#endif
 
 int maxname = 8, maxline = 8, maxhost = 16;
 int etype = 1 << USER_PROCESS;
 static int numutmp = 0;
 static struct utmpentry *ehead;
 
-#if defined(SUPPORT_UTMPX) || defined(SUPPORT_UTMP)
 static void
 adjust_size(struct utmpentry *e)
 {
@@ -118,36 +103,18 @@ setup(const char *fname)
 	const char *sfname;
 
 	if (fname == NULL) {
-#ifdef SUPPORT_UTMPX
 		setutxent();
-#endif
-#ifdef SUPPORT_UTMP
-		setutent();
-#endif
 	} else {
 		size_t len = strlen(fname);
 		if (len == 0)
 			errx(1, "Filename cannot be 0 length.");
 		what = fname[len - 1] == 'x' ? 1 : 2;
 		if (what == 1) {
-#ifdef SUPPORT_UTMPX
 			if (utmpxname(fname) == 0)
 				warnx("Cannot set utmpx file to `%s'",
 				    fname);
-#else
-			warnx("utmpx support not compiled in");
-#endif
-		} else {
-#ifdef SUPPORT_UTMP
-			if (utmpname(fname) == 0)
-				warnx("Cannot set utmp file to `%s'",
-				    fname);
-#else
-			warnx("utmp support not compiled in");
-#endif
 		}
 	}
-#ifdef SUPPORT_UTMPX
 	if (what & 1) {
 		sfname = fname ? fname : _PATH_UTMPX;
 		if (stat(sfname, &st) == -1) {
@@ -160,36 +127,15 @@ setup(const char *fname)
 			    what &= ~1;
 		}
 	}
-#endif
-#ifdef SUPPORT_UTMP
-	if (what & 2) {
-		sfname = fname ? fname : _PATH_UTMP;
-		if (stat(sfname, &st) == -1) {
-			warn("Cannot stat `%s'", sfname);
-			what &= ~2;
-		} else {
-			if (timespeccmp(&st.st_mtimespec, &utmptime, >))
-				utmptime = st.st_mtimespec;
-			else
-				what &= ~2;
-		}
-	}
-#endif
 	return what;
 }
-#endif
 
 void
 endutentries(void)
 {
 	struct utmpentry *ep;
 
-#ifdef SUPPORT_UTMP
-	timespecclear(&utmptime);
-#endif
-#ifdef SUPPORT_UTMPX
 	timespecclear(&utmpxtime);
-#endif
 	ep = ehead;
 	while (ep) {
 		struct utmpentry *sep = ep;
@@ -203,13 +149,7 @@ endutentries(void)
 int
 getutentries(const char *fname, struct utmpentry **epp)
 {
-#ifdef SUPPORT_UTMPX
 	struct utmpx *utx;
-#endif
-#ifdef SUPPORT_UTMP
-	struct utmp *ut;
-#endif
-#if defined(SUPPORT_UTMP) || defined(SUPPORT_UTMPX)
 	struct utmpentry *ep;
 	int what = setup(fname);
 	struct utmpentry **nextp = &ehead;
@@ -223,9 +163,7 @@ getutentries(const char *fname, struct utmpentry **epp)
 		ehead = NULL;
 		numutmp = 0;
 	}
-#endif
 
-#ifdef SUPPORT_UTMPX
 	while ((what & 1) && (utx = getutxent()) != NULL) {
 		if (fname == NULL && ((1 << utx->ut_type) & etype) == 0) {
 			continue;
@@ -238,34 +176,8 @@ getutentries(const char *fname, struct utmpentry **epp)
 		*nextp = ep;
 		nextp = &(ep->next);
 	}
-#endif
 
-#ifdef SUPPORT_UTMP
-	if ((etype & (1 << USER_PROCESS)) != 0) {
-		while ((what & 2) && (ut = getutent()) != NULL) {
-			if (fname == NULL && (*ut->ut_name == '\0' ||
-			    *ut->ut_line == '\0'))
-				continue;
-			/* Don't process entries that we have utmpx for */
-			for (ep = ehead; ep != NULL; ep = ep->next) {
-				if (strncmp(ep->line, ut->ut_line,
-				    sizeof(ut->ut_line)) == 0)
-					break;
-			}
-			if (ep != NULL)
-				continue;
-			if ((ep = calloc(1, sizeof(*ep))) == NULL) {
-				warn(NULL);
-				return 0;
-			}
-			getentry(ep, ut);
-			*nextp = ep;
-			nextp = &(ep->next);
-		}
-	}
-#endif
 	numutmp = 0;
-#if defined(SUPPORT_UTMP) || defined(SUPPORT_UTMPX)
 	if (ehead != NULL) {
 		struct utmpentry *from = ehead, *save;
 		
@@ -284,50 +196,8 @@ getutentries(const char *fname, struct utmpentry **epp)
 	}
 	*epp = ehead;
 	return numutmp;
-#else
-	*epp = NULL;
-	return 0;
-#endif
-}
-
-#ifdef SUPPORT_UTMP
-static void
-getentry(struct utmpentry *e, struct utmp *up)
-{
-#if 1
-	COMPILE_ASSERT(sizeof(e->name) > sizeof(up->ut_name));
-	COMPILE_ASSERT(sizeof(e->line) > sizeof(up->ut_line));
-	COMPILE_ASSERT(sizeof(e->host) > sizeof(up->ut_host));
-#endif
-
-	/*
-	 * e has just been calloc'd. We don't need to clear it or
-	 * append null-terminators, because its length is strictly
-	 * greater than the source string. Use strncpy to _read_
-	 * up->ut_* because they may not be terminated. For this
-	 * reason we use the size of the _source_ as the length
-	 * argument.
-	 */
-
-	snprintf(e->name, sizeof(e->name), "%.*s",
-		 (int)sizeof(up->ut_name), up->ut_name);
-	snprintf(e->line, sizeof(e->line), "%.*s",
-		 (int)sizeof(up->ut_line), up->ut_line);
-	snprintf(e->host, sizeof(e->host), "%.*s",
-		 (int)sizeof(up->ut_host), up->ut_host);
-
-	e->tv.tv_sec = up->ut_time;
-	e->tv.tv_usec = 0;
-	e->pid = 0;
-	e->term = 0;
-	e->exit = 0;
-	e->sess = 0;
-	e->type = USER_PROCESS;
-	adjust_size(e);
 }
-#endif
 
-#ifdef SUPPORT_UTMPX
 static void
 getentryx(struct utmpentry *e, struct utmpx *up)
 {
@@ -358,4 +228,3 @@ getentryx(struct utmpentry *e, struct utmpx *up)
 	e->type = up->ut_type;
 	adjust_size(e);
 }
-#endif
diff --git a/usr.bin/who/utmpentry.h b/usr.bin/who/utmpentry.h
index 6ebd8937e2..0bf93d0371 100644
--- a/usr.bin/who/utmpentry.h
+++ b/usr.bin/who/utmpentry.h
@@ -29,19 +29,10 @@
  * POSSIBILITY OF SUCH DAMAGE.
  */
 
-#if defined(SUPPORT_UTMPX)
-# include <utmpx.h>
-# define WHO_NAME_LEN		_UTX_USERSIZE
-# define WHO_LINE_LEN		_UTX_LINESIZE
-# define WHO_HOST_LEN		_UTX_HOSTSIZE
-#elif defined(SUPPORT_UTMP)
-# include <utmp.h>
-# define WHO_NAME_LEN		UT_NAMESIZE
-# define WHO_LINE_LEN		UT_LINESIZE
-# define WHO_HOST_LEN		UT_HOSTSIZE
-#else
-# error Either SUPPORT_UTMPX or SUPPORT_UTMP must be defined!
-#endif
+#include <utmpx.h>
+#define WHO_NAME_LEN		_UTX_USERSIZE
+#define WHO_LINE_LEN		_UTX_LINESIZE
+#define WHO_HOST_LEN		_UTX_HOSTSIZE
 
 
 struct utmpentry {
diff --git a/usr.bin/who/who.c b/usr.bin/who/who.c
index ab9aff8c2e..3d2bd24ca9 100644
--- a/usr.bin/who/who.c
+++ b/usr.bin/who/who.c
@@ -45,12 +45,7 @@
 #include <string.h>
 #include <time.h>
 #include <unistd.h>
-#ifdef SUPPORT_UTMP
-#include <utmp.h>
-#endif
-#ifdef SUPPORT_UTMPX
 #include <utmpx.h>
-#endif
 
 #include "utmpentry.h"
 
@@ -73,7 +68,6 @@ struct ut_type_names {
   int type;
   const char *name;
 } ut_type_names[] = {
-#ifdef SUPPORT_UTMPX
   { EMPTY, "empty" },
   { RUN_LVL, "run level" },
   { BOOT_TIME, "boot time" },
@@ -86,7 +80,6 @@ struct ut_type_names {
   { ACCOUNTING, "accounting" },
   { SIGNATURE, "signature" },
   { DOWN_TIME, "down time" },
-#endif /* SUPPORT_UTMPX */
   { -1, "unknown" }
 };
 
diff --git a/usr.bin/write/Makefile b/usr.bin/write/Makefile
index 7de9cc6208..8dc09e5eaf 100644
--- a/usr.bin/write/Makefile
+++ b/usr.bin/write/Makefile
@@ -10,6 +10,6 @@ BINGRP=	tty
 DPADD+=	${LIBUTIL}
 LDADD+=	-lutil
 
-CFLAGS+= -I${.CURDIR}/../who -DSUPPORT_UTMP -DSUPPORT_UTMPX
+CFLAGS+= -I${.CURDIR}/../who
 
 .include <bsd.prog.mk>
diff --git a/usr.bin/wtmpcvt/Makefile b/usr.bin/wtmpcvt/Makefile
new file mode 100644
index 0000000000..0caa097be1
--- /dev/null
+++ b/usr.bin/wtmpcvt/Makefile
@@ -0,0 +1,5 @@
+# $FreeBSD$
+
+PROG=	wtmpcvt
+
+.include <bsd.prog.mk>
